#******************************************************
# Adds a material layer to every material in a scene
# that isn't a mixed material or other material that
# can't accept layers
# 
# - addlayertoall.py
# - By Mark Caldwell
# - Version 0.4
# - Version 0.4 27th September 2009
# - Copyright Mark Caldwell 2009
# - Tested with Vue 7.5 Infinite and Vue R5 (2020)
#
# How to use in 3 easy steps
#
# 1. Download this file onto your computer
#
# 2. Edit the python script to set the material to
#    be added as a layer following the instructions
#    below
#
# 3. Then run script and wait for it to work
#    To run it go to Python -> Run Python Script
#    Then locate the file on your computer
#
#******************************************************

#----------------------------------------------
# Configuration: Change matname to change the
# material to be added.  Matname should be
# set to the filename of the material to be
# used but don't put .mat on the end.
# It may not be the same as the material name
# displayed in Vue.
#
# For example the material Varnish has a filename
# Varnish 1.mat so to use it you would replace
# Default on the line below with Varnish 1
# so the line would read matname="Varnish 1"
#----------------------------------------------

matname=""

#----------------------------------------------
# Do Not Edit Anything After Here
#----------------------------------------------

#----------------------------------------------
# Find Selected Objects Calculate the Centre
#----------------------------------------------

SelectAll()
countobj=CountSelectedObjects()
firstadd=0
matcheckname=""

if countobj>0:
    for i in range(0,countobj):
        SelectAll()
        obj=GetSelectedObjectByIndex(i)
        SelectOnly (obj)
        countmaterial=obj.CountMaterials ()
        if countmaterial>0:
            for j in range (0,countmaterial):
                DeselectAll()
                SelectOnly (obj)
                index=obj.Material (j).CountLayers()
                if obj.Material (j).GetSubLayer(index-1).Name()!=matcheckname and obj.Material (j).Type()==0:
                    addlayer=obj.Material(j).AddLayer((index),matname)
                    if firstadd==0:
                        firstadd=1
                        matcheckname=obj.Material (j).GetSubLayer(index).Name()

DeselectAll()
                      
#----------------------------------------------
# Refresh Vue's Display
#----------------------------------------------

Refresh()

#----------------------------------------------
# End of Script
#----------------------------------------------    
